const robot = require('./robot')
const web = require('./web')
const {logger} = require("./utils/logger");
const {tr} = require("date-fns/locale");


/*******
 * 定时任务
 * **** */
function init() {
    // reportNodeStatus()
    reportDel()
    reportSearchPositions()
    reportAmount()
    logger.info('--定时任务 启动');
}

function reportNodeStatus() {
    const intervalInMilliseconds = 5000;
    setInterval(() => {
        // logger.info('当前1',robot.appMap);
        web.robotNodeStatus()
    }, intervalInMilliseconds);
}


//定时清理机器人
function reportDel() {
    const intervalInMilliseconds = 2000;
    setInterval(() => {
        // logger.info('当前1',robot.appMap);
        robot.appMap.forEach((value, key) => {
            if (value.id !== -1) {
                // logger.info(`清理没用机器人开始111！`,value);
                robot.delRobot(value)
            }
        });
    }, intervalInMilliseconds);
}


// 定时扫描，如果发现机器人关闭或者错误，并且停止时间超过1分钟以上了，就进行清仓检查
function reportSearchPositions() {//DOTO node 代码修改完毕，待测试
    const intervalInMilliseconds = 1000 * 60;
    setInterval(() => {
        // logger.info('--当前 定时检查清仓');
        robot.appMap.forEach((value, key) => {
            logger.info('发起清仓检查：' + value.id + "停机时间：" + value.closeTime + "当前时间：" + new Date().getTime());

            let isStartTime = value.closeTime + (1000 * 60)
            if (value.id !== -1
                && isStartTime <= new Date().getTime()
                && (value.threadStatus === robot.RobotStatus.STOPPED || value.threadStatus === robot.RobotStatus.ERROR)
                // && value.isClearance === false
            ) {
                logger.info('--发起清仓' + value.id);

                robot.searchPositions({
                    "id": value.id,
                    "callPort": value.port,
                    "path": value.path,
                    "programName": value.programName,
                    "strategyName": value.strategyName,
                })
                // value.isClearance = true
            }
        });
    }, intervalInMilliseconds);
}


// 2秒一次对正在运行的,服务器进行余额比对，发生变化则上报
function reportAmount() {
    // 设置定时器，每隔一定时间（比如每隔5秒）发送一次GET请求
    const intervalInMilliseconds = 1000;
    setInterval(() => {
        // logger.info('当前2',robot.appMap);
        robot.appMap.forEach((value, key) => {
            var thisTime = new Date().getTime()
            if (value.threadStatus === robot.RobotStatus.RUNNING &&
                (thisTime - value.threadStartTime) > (1000 * 10)
            ) {
                robot.robotAmount(value)
            }
        });
    }, intervalInMilliseconds);
}


module.exports = {
    init
};